/*
 * Licensed Materials - Property of IBM
 *
 * Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA DP Schedule Contract with IBM Corp.
 */

</script>
	<div id="egl_loader" style="padding:50px; position:absolute;" >
		<img src="dojo/spinner.gif">
	</div>
<script>

setTimeout(function() {
	var loader = document.getElementById("egl_loader");
	if (loader) document.body.removeChild(loader);
}, 2000);

egl.startTime = new Date().getTime();

egl.startup = function(){
    //
	// DEBUG: enable the next line to see all the modules being loaded by Dojo
	//
	// dojo.connect(dojo, "eval", function(s) { s = s.replace(/&/g, "&amp;"); s = s.replace(/</g, "&lt;"); kkks(s);	});
}


egl.handleIDEEvent = function() {
	if(egl.canSendEventToIDE()){
		setInterval(function() {
			egl.loadIDEURL('___getevent', function(event) {
				try {
					if (event != "") {
						eval(event);
					}
		   		}
		   		catch (e) {
		   			if (egl) { // make sure the page is not destructed yet
		   				if (egl.egl.debug && e instanceof egl.egl.debug.DebugTermination) {
		   					if (e.msg) egl.println(e.msg);
		   				}
		   				else {
		   					if (event.match(/egl.partialTerminateSession().*/))
		   						document.location = document.location;
		   					else
		   						egl.printError(egl.getRuntimeMessage( "CRRUI2092E", [event]), e);
		   				}
		   			}
		   		}
			}, false);
		},1000);
	}
}

egl.handleIDEEvent = function() {
	if(egl.canSendEventToIDE()){
		egl.loadIDEURL('___getevent', function(event) {
			try {
				if (event != "") {
					eval(event);
				}
	   		}
	   		catch (e) {
	   			if (egl) { // make sure the page is not destructed yet
	   				if (egl.egl.debug && e instanceof egl.egl.debug.DebugTermination) {
	   					if (e.msg) egl.println(e.msg);
	   				}
	   				else {
	   					if (event.match(/egl.partialTerminateSession().*/))
	   						document.location = document.location;
	   					else
	   						egl.printError(egl.getRuntimeMessage( "CRRUI2092E", [event]), e);
	   				}
	   			}
	   		}
	   		if (window.setTimeout)
	   			window.setTimeout("if (window.egl) egl.handleIDEEvent()", 1000);
		}, false);
	}
}

egl.defineClass(
	'dojo.widgets', 'DojoBase',
	'egl.ui.rui', 'Widget',
{	
	"render" : function() {		
		this.renderingStep = 1;
		this.eze$$ready = false;
		this.renderingStep = 2;
		this.destroyAtRender();
		var marker = null;
		var style = this.eze$$DOMElement.style;
		this.renderingStep = 4;
		this.createDojoWidget(this.eze$$DOMElement);
		this.eze$$DOMElement = this.dojoWidget.domNode || this.dojoWidget.node;
		this.eze$$DOMElement.eze$$widget = this;
		this.renderingStep = 5;
		this.copyStyle(style);
		this.eze$$ready = true;
		this.printStartupMessage();
		egl.startVEWidgetTimer();
	},
	"reportError" : function(error) {
		var s = "<div style='padding:14px; width:350px; background: yellow; border: 2px solid red;'>"+
		"<font color=red><b>Error found in "+this.eze$$typename + "</b></font><br><br>" +
		"Parent hierarchy = " + this.getAncestry() +
		"<br><br>Could not create Dojo Widget. See "+this.eze$$typename + 
		".createDojoWidget(), rendering step="+this.renderingStep + 
			(error ? ", error=" + error : "") + "</div>";
		this.setInnerHTML(s);	
	},
	"destroyAtRender" : function() {
		this.destroy();
	},
	"printStartupMessage" : function() {
		if (egl.dojo.widgets.DojoDiagnostics && !egl.enableEditing && !egl.debugg && egl.contextAware && !egl.dojoNow) {
		    egl.dojoNow = new Date().getTime();
		    var duration = (egl.dojoNow-egl.startTime);
		    egl.println("<div style='border: 1px solid #555555; background-color: #E5F3FF; width:700px; padding: 9px;'><b>Dojo Statistics: </b>" +
		    		"Total startup (including loading of Dojo) took: <b>"+duration+
		    		"</b>ms.<hr>Dojo provider is: \"" + egl.dojoProvider + 
		    		"\".<br>Read <b>README_FIRST.html</b> in the <b>dojo.runtime</b> " +
		    		"project for more information.<br>" +
		    		"<hr>You are using: "+navigator.userAgent + (document.documentMode ? ", documentMode="+document.documentMode : "") +
		    		"<hr>This message is only printed in Preview mode, and not when you deploy or debug your application. See DojoDiagnostics.egl." +
		    		"</div>"
		    );
		    var http = "http:/";
			if (navigator.userAgent.indexOf("MSIE 6") != -1) 
			   egl.println("<font color=red><b>You are using IE6. For performance and security reasons, we "+
		    		"<a target=_blank href=" + http + "/www.stoplivinginthepast.com/why-upgrade/>strongly recommend</a> upgrading your browser. "+
		    		"Please <a target=_blank href=" + http + "/www.google.com/toolbar/ie8/>download</a> IE8.");
		}
	},
	"renderWhenDojoIsDoneLoading" : function() {
		var eglWidget = this;
		eglWidget.renderingStep = 0;
		if (egl.IE)
			setTimeout(function() {	
				eglWidget.renderWhenDojoIsDoneLoadingSafely();
			},1);
		else
			eglWidget.renderWhenDojoIsDoneLoadingSafely();
	},
	"renderWhenDojoIsDoneLoadingSafely" : function() {
		var eglWidget = this;
		dojo.addOnLoad(function(){
			try {
				eglWidget.render();
			}
			catch (e) {
				dojo.addOnLoad(function(){	
					try {
						eglWidget.render();
					}
					catch (e) {
						eglWidget.reportError(e.message);
					}
				});
			}
		});
		this.removeLoader();
	},
	"getAncestry" : function() {
		var s = "";
		var element = this.eze$$DOMElement;
		while (element && element != document.body.parentNode) {
			if (element == document.body) 
				s += "document.body";
			else
			if (element.tagName) 
				s += element.tagName + " &gt; ";
			else
				s += "<font color=red><b>NO PARENT</b></font>";
			element = element.parentNode;
		}
		return s;
	},
	"removeLoader" : function() {
		var loader = document.getElementById("egl_loader");
		if (loader)
			document.body.removeChild(loader);
	},
	"copyStyle" : function(style) {
		for (f in style)
			if (style[f] != "")
				try { this.eze$$DOMElement.style[f] = style[f]; } catch (e) { }
		if (this.width) egl.setWidth(this.dojoWidget.domNode, egl.toPX(this.width));
		if (this.height) egl.setHeight(this.dojoWidget.domNode, egl.toPX(this.height));
	},
	"setData" : function ( data ){
		this.data = data;
		var eglWidget = this;
		setTimeout(function() {
			eglWidget.renderWhenDojoIsDoneLoading();
		}, 1);
	},
	"getData" : function(){
		return this.data;
	},
	"setText" : function(text){
		this.text = text;
	},
	"getText" : function(){
		return this.text;
	},
	"setWidth" : function(width){ 
		this.width=width; 
		egl.setWidth(this.eze$$DOMElement, egl.toPX(width)); 
	},
	"setHeight" : function(height){ 
		this.height=height; 
		egl.setHeight(this.eze$$DOMElement, egl.toPX(height)); 
	},
	"setColor" : function(color){ 
		this.color=color; 
		egl.egl.ui.rui.Widget.prototype.setColor.call(this, color); 
	},
	"setFont" : function(font){ 
		this.font=font; 
		egl.egl.ui.rui.Widget.prototype.setFont.call(this, font); 
	},
	"includeCSS" : function(url) {
		var cssNode = document.createElement('link');
		cssNode.type = 'text/css';
		cssNode.rel = 'stylesheet';
		cssNode.href = url;
		document.getElementsByTagName("head")[0].appendChild(cssNode); 
	},
	"handleEvent" : function(handlers, name) {
		for (var n=0; n<handlers.length; n++) {
			try {
				handlers[n]({ 
					widget: this, 
					stopPropagation: function() { throw "this is a synthetic Dojo event. Cannot stop propogation."; }, 
					preventDefault: function() { throw "this is a synthetic Dojo event. Cannot prevent default behavior."; } 
				});
			}
			catch(e) {
				if (egl.egl.debug && e instanceof egl.egl.debug.DebugTermination){
		    		throw e;
		    	}
				egl.printError("Uncaught exception occurred during handling of "+this.eze$$type+"."+name+" event", e);
			}
		}
	},
	"destroy" : function(){
		try { this.dojoWidget.destroy(); } catch(e) { }
		try { this.dojoWidget.destroyRecursive(); } catch (e) { }
		this.dojoWidget = null;
	},
	"layout" : function(){
		try { this.dojoWidget.layout(); } catch(e) { }
	},
	"assert" : function(test, message) {
		if (!test)
			throw message + ". Race condition may have occurred.";
	}
});

