/*
 * Licensed Materials - Property of IBM
 *
 * Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA DP Schedule Contract with IBM Corp.
 */

egl.defineWidget(
	'dojo.widgets', 'DojoTitlePane',
	'dojo.widgets', 'DojoContainer',
	'div',
{
	"constructor" : function() {
		dojo.require("dijit.TitlePane");
		this.open = true;
	},
	"destroyAtRender" : function() {
		this.destroy();
	},
	"copyStyle" : function(style) {
		egl.dojo.widgets.DojoBase.prototype.copyStyle.call(this, style);
		for (var n=0; n<this.children.length; n++) {
			this.content.appendChild(this.children[n].eze$$DOMElement);			
		}
	},
	"createDojoWidget" : function(parent){
		this.content = egl.createChild(this.eze$$DOMElement, "div");
		this.dojoWidget = new dijit.TitlePane({
			title: this.title || "", 
			open: this.open,
			content: this.content,
			duration: this.duration || 250
		}, parent);
		this.dojoWidget.startup();
	},
	"getOpen" : function(){
		if (this.dojoWidget)
			this.open = this.dojoWidget.open;
		return this.open;
	},
	"setOpen" : function(open){
		this.open = open;
	},
	"toggle" : function(){
		this.dojoWidget.toggle();
	}

});