/*
 * Licensed Materials - Property of IBM
 *
 * Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA DP Schedule Contract with IBM Corp.
 */

egl.defineWidget(
	'dojo.widgets', 'DojoCalendar',
	'dojo.widgets', 'DojoBase',
	'div',
{
	"constructor" : function() {
		var eglWidget = this;
		setTimeout(function() {
			eglWidget.renderWhenDojoIsDoneLoading();
		},1);		
		dojo.require("dijit._Calendar"); 	
	},
	"createDojoWidget" : function(parent) {
		var date = new Date();
		this.dojoWidget = new dijit._Calendar({value: date}, parent);
		this.dojoWidget.startup();
  	},
	"setValue": function(value) {
		if (this.dojoWidget)
			this.dojoWidget.attr("value",value);
	},
	"getValue" : function() {
		if (this.dojoWidget)
			return this.dojoWidget.attr("value");
		else
			return null;
	}
});