/*
 * Licensed Materials - Property of IBM
 *
 * Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA DP Schedule Contract with IBM Corp.
 */

egl.defineWidget(
	'dojo.widgets', 'DojoTooltip',
	'dojo.widgets', 'DojoBase',
	'div',
{
	"constructor" : function() {
		var eglWidget = this;
		setTimeout(function() {
			eglWidget.renderWhenDojoIsDoneLoading();
		},1);		
		dojo.require("dijit.Tooltip"); 
	},
	"createDojoWidget" : function(parent) {
		this.dojoWidget = new dijit.Tooltip({
            connectId: this.target || [],
            label: this.contents || "",
            showDelay: this.delay || 10,
            defaultPosition: this.defaultPosition || []
        });
		this.dojoWidget.startup();
	}
});