/*
 * Licensed Materials - Property of IBM
 *
 * Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA DP Schedule Contract with IBM Corp.
 */

//
// Insert your Google Maps API key below, replacing the XXXXXXXX. See http://www.google.com/apis/maps/signup.html
//
</script><script src="http://maps.google.com/maps?file=api&v=2&key=XXXXXXXX"
></script><script>	

egl.removeThisMessageForGoogleMap = "Insert your Google Maps API key above, and remove this message";

egl.defineWidget(
	'utils', 'GoogleMap',  		// this class
	'egl.ui.rui', 'Widget',  	// the super class
	'div',						// dom element type name
{
	"constructor" : function() {
		this.width = 400;
		this.height = 300;
	},
	"destroy" : function() {
		if (window.GUnload)	GUnload();	
	},	
	"showAddress" : function( /*String*/ address, /*String*/ description ) {
		if (egl.removeThisMessageForGoogleMap) {
			this.setInnerHTML("Enter your Google Maps API key in the <b>WebContent/utils/GoogleMap.js</b> file to enable Google Maps.");
			this.setPadding(10);
			this.setBackground("yellow");
			return;
		}
		if (!this.map) {
			this.map = new GMap2(this.eze$$DOMElement, {size:new GSize(this.width,this.height)});
			this.map.addControl(new GSmallMapControl());
			this.map.addControl(new GMapTypeControl());
		}
		var map = this;
		map.address = address;
		map.description = description;
		new GClientGeocoder().getLatLng(
			map.address,
			function( point ){
				if (!point) {
					alert(map.address + " not found");
				} else {
					map.map.setCenter(point, 13);
					var marker = new GMarker(point);
					map.map.addOverlay(marker);
					marker.openInfoWindowHtml(map.description+"<br>"+map.address);
				}
			}
		);
	}
});

