/*
 * Licensed Materials - Property of IBM
 *
 * Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA DP Schedule Contract with IBM Corp.
 */

egl.defineWidget(
	'dojo.widgets', 'DojoContextMenu',
	'dojo.widgets', 'DojoMenu',
	'div',
{
	"constructor" : function() {
		this.setChildType("dojo.widgets.DojoMenuItem");
		dojo.require("dijit.Menu");
	},
	"createDojoWidget" : function() {
		var nodes = [];
		for (var i=0; i < this.targets.length; i++ )
			nodes[i] = this.targets[i].eze$$DOMElement; 
		this.dojoWidget = new dijit.Menu({targetNodeIds : nodes });
		this.dojoMenu = this.dojoWidget;
		this.startup();
	},
	"setTargets" : function( targets ) {
		this.targets = targets;
	},
	"getTargets" : function(){
		return this.targets;
	}
});